routes/web.php
<?php

use App\Http\Controllers\AdresseController;
use App\Http\Controllers\CaracteristiqueController;
use App\Http\Controllers\CategorieProduitController;
use App\Http\Controllers\ClientController;
use App\Http\Controllers\ClimatController;
use App\Http\Controllers\CommandeController;
use App\Http\Controllers\DinosaureController;
use App\Http\Controllers\EnclosController;
use App\Http\Controllers\EnvironnementController;
use App\Http\Controllers\EspeceController;
use App\Http\Controllers\PersonnelController;
use App\Http\Controllers\ProduitController;
use App\Http\Controllers\TaxeController;
use App\Http\Controllers\TypeEnclosController;
use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/
//Route::get('/dashboard', function () {
//    return view('dashboard');
//})->middleware(['auth'])->name('dashboard');
//
//require __DIR__.'/auth.php';

Route::get('/admin', function () {
    return view('pages/admin/index');
})->middleware(['auth'])->name('admin.index');

Route::prefix('admin')->middleware(['auth'])->group(function () {
    Route::resource('/personnels', PersonnelController::class);
    Route::resource('/enclos', EnclosController::class);
    Route::resource('/taxes', TaxeController::class);
    Route::resource('/produits', ProduitController::class);
    Route::resource('/categories-produits', CategorieProduitController::class);
    Route::resource('/dinosaures', DinosaureController::class);
    Route::resource('/especes', EspeceController::class);
    Route::resource('/caracteristiques', CaracteristiqueController::class);
    Route::resource('/climats', ClimatController::class);
    Route::resource('/environnements', EnvironnementController::class);
    Route::resource('/types-enclos', TypeEnclosController::class);
    Route::resource('/adresses', AdresseController::class);
//    Route::resource('/clients', ClientController::class);
    Route::get('/clients', [ClientController::class, 'index'])->name('clients.index');
    Route::get('/clients/{client}/edit', [ClientController::class, 'edit'])->name('clients.edit');
    Route::put('/clients/{client}', [ClientController::class, 'update'])->name('clients.update');
    Route::delete('/clients/{client}', [ClientController::class, 'destroy'])->name('clients.destroy');
});

require __DIR__.'/auth.php';

Route::get('/clients/create/{userId}', [ClientController::class, 'create'])->name('clients.create');
Route::post('/clients', [ClientController::class, 'store'])->name('clients.store');
Route::post('/clients/{client}', [ClientController::class, 'store'])->name('clients.show');

Route::post('/adresse', [AdresseController::class, 'store'])->name('adresse.store');
Route::get('/boutique', [CommandeController::class, 'index'])->name('boutique.index');
Route::post('/panier', [CommandeController::class, 'create'])->name('panier.create');
Route::put('/panier', [CommandeController::class, 'store'])->middleware(['auth'])->name('panier.store');

Route::get('/', [DinosaureController::class, 'homepage'])->name('homepage');

app/Models/Produit.php
<?php

namespace App\Models;

use Carbon\Carbon;
use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Support\Str;

class Produit extends Model
{
    use HasFactory;

    protected $fillable = ['nom', 'prix', 'quantite', 'image', 'taxe_id', 'categorie_produit_id'];

    public function commandes(){
        return $this->belongsToMany(Commande::class, 'lignes_commandes', 'produit_id', 'commande_id')
            ->withTimestamps();
    }

    public function clients(){
        return $this->belongsToMany(Client::class, 'panier', 'produit_id', 'client_id')
            ->withPivot('quantite')
            ->withTimestamps();
    }

    public function categorie() {
        return $this->belongsTo(CategorieProduit::class, 'categorie_produit_id');
    }

    public function taxe() {
        return $this->belongsTo(Taxe::class);
    }

    public function slugName() {
        $slugName = Str::slug($this->attributes['nom']) . '-'. Carbon::now()->format('Y-m-d');
        return $slugName;
    }
}

app/Models/Taxe.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Taxe extends Model
{
    use HasFactory;

    protected $fillable = ['taux'];

    public function produits(){
        return $this->hasMany(Produit::class);
    }

    public function getTauxAsPercentageAttribute() {
        return $this->attributes['taux'] * 100;
    }
}

app/Http/Controllers/ProduitController.php
<?php

namespace App\Http\Controllers;

use App\Models\CategorieProduit;
use App\Models\Produit;
use App\Models\Taxe;
use Illuminate\Http\Request;

class ProduitController extends Controller
{
    public function index() {
        $categories = CategorieProduit::pluck('nom','id');;
        $taxes = Taxe::pluck('taux','id');;
        $produits = Produit::with(['categorie', 'taxe'])
            ->get();
        return view('pages/admin/produit/index', [
            'produits' => $produits,
            'categories' => $categories,
            'taxes' => $taxes
        ]);
    }

    public function create() {
        $categories = CategorieProduit::pluck('nom','id');
        $taxes = Taxe::pluck('taux','id');
        return view('pages/admin/produit/create', [
            'categories' => $categories,
            'taxes' => $taxes
        ]);
    }

    public function store(Request $request) {
        $produit = Produit::create($request->all());
        $imageName = $produit->slugName() . '.' . $request->file('image')->extension();

        $request->file('image')->storeAs('public', $imageName);
        $produit->image = $imageName;
        $produit->save();
        return redirect()->route('produits.index');
    }

    public function edit($produitId) {
        $produit = Produit::find($produitId);
        $taxes = Taxe::pluck('taux', 'id');
        $categories = CategorieProduit::pluck('nom', 'id');
        return view('pages/admin/produit/edit', [
            "produit" => $produit,
            "taxes" => $taxes,
            "categories" => $categories,
        ]);
    }

    public function update(Request $request, Produit $produit) {
        $produit->update($request->all());
        $imageName = $produit->slugName() . '.' . $request->file('image')->extension();

        $request->file('image')->storeAs('public', $imageName);
        $produit->image = $imageName;
        $produit->save();
        return redirect()->route('produits.index');
    }

    public function destroy(Produit $produit) {
        $produit->delete();
        return redirect()->route('produits.index');
    }
}

resources/views/pages/admin/produit/create.blade.php
@extends('layouts.admin-layout')

@section('content')
    <div class="row">
        <div class="col-md-7 mx-auto">
            {!! Form::open(["method" => "POST", "route" => "produits.store", 'files' => true]) !!}
            <label for="nom">Nom du produit</label>
            {!! Form::text("nom", null, ["class" => "form-group form-control"]) !!}
            <label for="prix">Prix HT</label>
            {!! Form::number("prix", null, ["class" => "form-group form-control", "step" => "0.01"]) !!}
            <label for="quantite">Quantité en stock</label>
            {!! Form::number("quantite", null, ["class" => "form-group form-control"]) !!}
            <div class="input-group mb-3">
                <div class="input-group-prepend">
                    <label for="categorie_produit_id" class="input-group-text text-dark">Catégorie</label>
                </div>
                {!! Form::select("categorie_produit_id", $categories, ["class" => "custom-select"]) !!}
            </div>
            <div class="input-group mb-3">
                <div class="input-group-prepend">
                    <label for="taxe_id" class="input-group-text text-dark">Taxe</label>
                </div>
                {!! Form::select("taxe_id", $taxes, ["class" => "custom-select"]) !!}
            </div>

            <div class="input-group mb-3">
                <label for="image" class="form-label">Image : </label>
                    {!! Form::file('image', ["class" => "form-control"]) !!}
            </div>

            {!! Form::submit("Ajouter le produit", ["class" => "btn btn-success"]) !!}
            {!! Form::close() !!}
        </div>
    </div>


    <!-- Modal -->
    <div class="modal fade" id="new-address" tabindex="-1" aria-labelledby="modal-new-address" aria-hidden="true">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Ajouter une adresse</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    {!! Form::open(["method" => "POST", "route" => ["adresse.store"], "id" => "new-address-form"] ) !!}
                    <label for="numero">Numéro</label>
                    {!! Form::number("numero", null, ["class" => "form-group form-control"]) !!}
                    <label for="rue">Rue</label>
                    {!! Form::text("rue", null, ["class" => "form-group form-control"]) !!}
                    <label for="cp">Code Postal</label>
                    {!! Form::text("cp", null, ["class" => "form-group form-control"]) !!}
                    <label for="ville">Ville</label>
                    {!! Form::text("ville", null, ["class" => "form-group form-control"]) !!}

                    <div class="modal-footer">
                        <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Fermer</button>
                        <button type="button" id="save-address" class="btn btn-primary" data-bs-dismiss="modal">Enregistrer l'adresse</button>
                    </div>

                    {!! Form::close() !!}
                </div>

            </div>
        </div>
    </div>
@endsection

resources/views/pages/admin/produit/edit.blade.php
@extends('layouts.admin-layout')

@section('content')
    <div class="row">
        <div class="col-md-4">
            Photo
        </div>
        <div class="col-md-8">
            {!! Form::model($produit, ["method" => "PUT", "route" => ["produits.update", $produit], 'files' => true]) !!}
            <label for="nom">Nom</label>
            {!! Form::text("nom", $produit->nom, ["class" => "form-group form-control"]) !!}
            <label for="quantite">Quantité en stock</label>
            {!! Form::number("quantite", $produit->quantite, ["class" => "form-group form-control", "step" => 1]) !!}
            <label for="prix">Prix HT</label>
            {!! Form::number("prix", $produit->prix, ["class" => "form-group form-control", "step" => 1]) !!}
            <div class="input-group mb-3">
                <div class="input-group-prepend">
                    <label for="taxe_id" class="input-group-text text-dark">Taxe</label>
                </div>
                {!! Form::select("taxe_id", $taxes, ["class" => "custom-select"]) !!}
            </div>

            <div class="input-group mb-3">
                <div class="input-group-prepend">
                    <label for="categorie_id" class="input-group-text text-dark">Catégorie</label>
                </div>
                {!! Form::select("categorie_id", $categories, ["class" => "custom-select"]) !!}
            </div>

            <div class="input-group mb-3">
                <label for="image" class="form-label">Image : </label>
                {!! Form::file('image', ["class" => "form-control"]) !!}
            </div>
            {!! Form::submit("Mettre à jour", ["class" => "btn btn-success"]) !!}
            {!! Form::close() !!}
        </div>
    </div>
@endsection

resources/views/pages/admin/produit/index.blade.php
@extends('layouts.admin-layout')

@section('content')
<table class="table">
    <thead>
    <tr>
        <th scope="col">Nom</th>
        <th scope="col">Prix</th>
        <th scope="col">Quantité</th>
        <th scope="col">Taxe</th>
        <th scope="col">Catégorie</th>
    </tr>
    </thead>
    <tbody>
    @foreach($produits as $produit)
    <tr>
        <td>{{$produit->nom}}</td>
        <td>{{$produit->prix}}</td>
        <td>{{$produit->quantite}}</td>
        <td>{{$produit->taxe->taux_as_percentage}} %</td>
        <td><a href="{{ route('categories-produits.show', $produit->categorie->id) }}">{{$produit->categorie->nom}}</a></td>
        <td>
        <td><a href="{{ route('produits.show',$produit) }}"><i class="fas fa-eye"></i></a></td>
        <td><a href="{{ route('produits.edit',$produit) }}"><i class="fas fa-edit"></i></a></td>
        <td>
            {!! Form::open(["method" => "DELETE", "route" => ["produits.destroy", "produit" => $produit]]) !!}
            {{ Form::button('<i class="fas fa-trash"></i>', ['type' => 'submit', 'class' => 'btn'    ] )  }}

            {!! Form::close() !!}
        </td>
    </tr>
    @endforeach
    </tbody>
</table>

<a href="{{route('produits.create')}}" class="btn btn-success">
    Ajouter un produit
</a>

@endsection